/*
 * CurrentState.java
 *
 * Generated by Protege plugin Beanynizer. 
 * Changes will be lost! 
 */
package jadex.tools.ontology;

import jadex.runtime.SystemEvent;
import java.util.ArrayList;
import java.util.List;


/**
 *  Java class for concept CurrentState of jadex.tools.introspector ontology.
 */
public class CurrentState	extends ToolRequest implements java.beans.BeanInfo 
{
	//-------- constants ----------

	//-------- attributes ----------

	/** System events that occurred inside the observed agent. */
	protected  List  systemevents;

	/** The system event types to be propagated to the tool. */
	protected  List  eventtypes;

	//-------- constructors --------

	/**
	 *  Default Constructor. <br>
	 *  Create a new <code>CurrentState</code>.
	 */
	public CurrentState()  {
		this.systemevents  = new ArrayList();
		this.eventtypes  = new ArrayList();
	}

	/**
	 *  Init Constructor. <br>
	 *  Create a new CurrentState.<br>
	 *  Initializes the object with required attributes.
	 * @param tooltype
	 */
	public CurrentState(String tooltype)  {
		this();
		setToolType(tooltype);
	}

	//-------- accessor methods --------

	/**
	 *  Get the system-events of this CurrentState.
	 *   System events that occurred inside the observed agent.
	 * @return system-events
	 */
	public SystemEvent[]  getSystemEvents() {
		return (SystemEvent[])systemevents.toArray(new SystemEvent [systemevents.size()]);
	}

	/**
	 *  Set the system-events of this CurrentState.
	 *  System events that occurred inside the observed agent.
	 * @param systemevents the value to be set
	 */
	public void  setSystemEvents(SystemEvent[] systemevents) {
		this.systemevents.clear();
		for(int i=0; i<systemevents.length; i++)
			this.systemevents.add(systemevents[i]);
	}

	/**
	 *  Get an system-events of this CurrentState.
	 *  System events that occurred inside the observed agent.
	 *  @param idx The index.
	 *  @return system-events
	 */
	public SystemEvent  getSystemEvent(int idx) {
		return (SystemEvent)this.systemevents.get(idx);
	}

	/**
	 *  Set a system-event to this CurrentState.
	 *  System events that occurred inside the observed agent.
	 *  @param idx The index.
	 *  @param systemevent a value to be added
	 */
	public void  setSystemEvent(int idx, SystemEvent systemevent) {
		this.systemevents.set(idx, systemevent);
	}

	/**
	 *  Add a system-event to this CurrentState.
	 *  System events that occurred inside the observed agent.
	 *  @param systemevent a value to be removed
	 */
	public void  addSystemEvent(SystemEvent systemevent)  {
		this.systemevents.add(systemevent);
	}

	/**
	 *  Remove a system-event from this CurrentState.
	 *  System events that occurred inside the observed agent.
	 *  @param systemevent a value to be removed
	 *  @return  True when the system-events have changed.
	 */
	public boolean  removeSystemEvent(SystemEvent systemevent)  {
		return this.systemevents.remove(systemevent);
	}


	/**
	 *  Get the event-types of this CurrentState.
	 *   The system event types to be propagated to the tool.
	 * @return event-types
	 */
	public String[]  getEventTypes() {
		return (String[])eventtypes.toArray(new String [eventtypes.size()]);
	}

	/**
	 *  Set the event-types of this CurrentState.
	 *  The system event types to be propagated to the tool.
	 * @param eventtypes the value to be set
	 */
	public void  setEventTypes(String[] eventtypes) {
		this.eventtypes.clear();
		for(int i=0; i<eventtypes.length; i++)
			this.eventtypes.add(eventtypes[i]);
	}

	/**
	 *  Get an event-types of this CurrentState.
	 *  The system event types to be propagated to the tool.
	 *  @param idx The index.
	 *  @return event-types
	 */
	public String  getEventType(int idx) {
		return (String)this.eventtypes.get(idx);
	}

	/**
	 *  Set a event-type to this CurrentState.
	 *  The system event types to be propagated to the tool.
	 *  @param idx The index.
	 *  @param eventtype a value to be added
	 */
	public void  setEventType(int idx, String eventtype) {
		this.eventtypes.set(idx, eventtype);
	}

	/**
	 *  Add a event-type to this CurrentState.
	 *  The system event types to be propagated to the tool.
	 *  @param eventtype a value to be removed
	 */
	public void  addEventType(String eventtype)  {
		this.eventtypes.add(eventtype);
	}

	/**
	 *  Remove a event-type from this CurrentState.
	 *  The system event types to be propagated to the tool.
	 *  @param eventtype a value to be removed
	 *  @return  True when the event-types have changed.
	 */
	public boolean  removeEventType(String eventtype)  {
		return this.eventtypes.remove(eventtype);
	}


	//-------- bean related methods --------

	/** The property descriptors, constructed on first access. */
	private java.beans.PropertyDescriptor[] pds = null;

	/**
	 *  Get the bean descriptor.
	 *  @return The bean descriptor.
	 */
	public java.beans.BeanDescriptor getBeanDescriptor() {
		return null;
	}

	/**
	 *  Get the property descriptors.
	 *  @return The property descriptors.
	 */
	public java.beans.PropertyDescriptor[] getPropertyDescriptors() {
		if(pds==null) {
			try {
				pds = new java.beans.PropertyDescriptor[]{
					 new java.beans.IndexedPropertyDescriptor("systemEvents", this.getClass(),
						"getSystemEvents", "setSystemEvents", "getSystemEvent", "setSystemEvent")
					, new java.beans.IndexedPropertyDescriptor("eventTypes", this.getClass(),
						"getEventTypes", "setEventTypes", "getEventType", "setEventType")
				};
				java.beans.PropertyDescriptor[] spds = super.getPropertyDescriptors();
				int	l1	= pds.length;
				int	l2	= spds.length;
				Object	res	= java.lang.reflect.Array.newInstance(java.beans.PropertyDescriptor.class, l1+l2);
				System.arraycopy(pds, 0, res, 0, l1);
				System.arraycopy(spds, 0, res, l1, l2);
				pds = (java.beans.PropertyDescriptor[])res;
			}
			catch(Exception e) {
				e.printStackTrace();
			}
		}
		return pds;
	}

	/**
	 *  Get the default property index.
	 *  @return The property index.
	 */
	public int getDefaultPropertyIndex() {
		return -1;
	}

	/**
	 *  Get the event set descriptors.
	 *  @return The event set descriptors.
	 */
	public java.beans.EventSetDescriptor[] getEventSetDescriptors() {
		return null;
	}

	/**
	 *  Get the default event index.
	 *  @return The default event index.
	 */
	public int getDefaultEventIndex() {
		return -1;
	}

	/**
	 *  Get the method descriptors.
	 *  @return The method descriptors.
	 */
	public java.beans.MethodDescriptor[] getMethodDescriptors() {
		return null;
	}

	/**
	 *  Get additional bean info.
	 *  @return Get additional bean info.
	 */
	public java.beans.BeanInfo[] getAdditionalBeanInfo() {
		return null;
	}

	/**
	 *  Get the icon.
	 *  @return The icon.
	 */
	public java.awt.Image getIcon(int iconKind) {
		return null;
	}

	/**
	 *  Load the image.
	 *  @return The image.
	 */
	public java.awt.Image loadImage(final String resourceName) {
		try {
			final Class c = getClass();
			java.awt.image.ImageProducer ip = (java.awt.image.ImageProducer)
				java.security.AccessController.doPrivileged(new java.security.PrivilegedAction() {
					public Object run(){
						java.net.URL url;
						if((url = c.getResource(resourceName))==null) {
							return null;
						}
						else {
							try {
								return url.getContent();
							}
							catch(java.io.IOException ioe) {
								return null;
							}
						}
					}
				});
			if(ip==null)
				return null;
			java.awt.Toolkit tk = java.awt.Toolkit.getDefaultToolkit();
			return tk.createImage(ip);
		}
		catch(Exception ex) {
			return null;
		}
	}

	//-------- additional methods --------

	/**
	 *  Get a string representation of this CurrentState.
	 *  @return The string representation.
	 */
	public String toString() {
		return "CurrentState("
		+ "tooltype="+getToolType()
           + ")";
	}

}
